//> ===>
//> Title: Event Favorites
//> Author: Truce
//> ===>

$EFD="config/client/EventFavorites/";
$EFT="fxDTSBrick";
function EFC(%n) {
	if(!WrenchEventsDlg.isAwake())
		return;
	%path=$EFD@%n@".cs";
	if($EFS) {
		deleteVariables("$EFF*");
		%l=-1;
		for(%i=0;%i<WrenchEvents_Box.getCount();%i++) {
			%r=WrenchEvents_Box.getObject(%l++);
			if(%r.getCount()>4) {
				%e=%r.getObject(2);
				if(!%e.createdNew)
					break;
				$EFFE[%i]=%r.getObject(0).getValue();
				$EFFD[%i]=%r.getObject(1).getValue();
				$EFFI[%i]=%e.getValue();
				%t=%r.getObject(3).getValue();
				$EFFT[%i]=%t;
				%o=0;
				if(%t$="<NAMED BRICK>") {
					$EFFN[%i]=%r.getObject(4).getValue();
					%o=1;
				}
				$EFFO[%i]=%r.getObject(4+%o).getValue();
				%c=%r.getCount();
				for(%j=0;%j<%c-5-%o;%j++) {
					%p=%r.getObject(%j+5+%o);
					if(%p.getClassName()$="GuiSwatchCtrl") {
						if(%p.value!$="")
							$EFFP[%i,%j]=%p.color;
						else
							$EFFP[%i,%j]=%p.getObject(0).getValue()@" "@%p.getObject(1).getValue()@" "@%p.getObject(2).getValue();
					}
					else
						$EFFP[%i,%j]=%p.getValue();
				}
				$EFFC[%i]=%j;
			}
			else
				%l--;
		}
		$EFFC=%l+1;
		export("$EFF*",%path);
		$EFB[%n].mColor="255 255 255 255";
		$EFS=0;
		EFH.setVisible(0);
	}
	else {
		if(!isFile(%path))
			return;
		exec(%path);
		if($EFFC==-1)
			return;
		wrenchEventsDlg.clear();
		%o=-1;
		for(%i=0;%i<$EFFC;%i++) {
			%r=WrenchEvents_Box.getObject(%o++);
			%t=%r.getObject(2);
			%n=%t.findText($EFFI[%i]);
			if(%n!=-1) {
				%t.setSelected(%n);
				%t=%r.getObject(3);
				%t.forceClose();
				%b=$EFFT[%i];
				%g=%t.findText(%b);
				if(%g!=-1||%b$="<NAMED BRICK>") {
					%t.setSelected(%g);
					%f=0;
					if(%b$="<NAMED BRICK>") {
						%t=%r.getObject(4);
						%t.forceClose();
						%l=%t.findText($EFFN[%i]);
						if(%l!=-1) {
							%t.setSelected(%l);
							%f=1;
						}
						else
							%e=1;
					}
					%t=%r.getObject(4+%f);
					%t.forceClose();
					%p=%t.findText($EFFO[%i]);
					if(%p!=-1) {
						%t.setSelected(%p);
						for(%j=0;%j<$EFFC[%i];%j++) {
							%s=%r.getObject(5+%f+%j);
							%w=getWord(getField($OutputEvent_parameterList[getWord(getField($InputEvent_TargetList[$EFT,%n],%g),1),%p],%j),0);
							if(%w$="paintColor") {
								if(!$EFP) {
									for(%k=0;%k<RootGroup.getCount();%k++) {
										%d=RootGroup.getObject(%k);
										if(%d.getName()$="PaintRow")
											$EFP+=%d.numSwatches;
									}
									$EFP-=9;
								}
								%x=$EFFP[%i,%j];
								%y="";
								for(%k=0;%k<$EFP;%k++) {
									%z=getColorIDTable(%k);
									%d=mAbs(getWord(%x,0)-getWord(%z,0))+mAbs(getWord(%x,1)-getWord(%z,1))+mAbs(getWord(%x,2)-getWord(%z,2));
									if(%y$=""||%d<%y) {
										%y=%d;
										%w=%k;
									}
								}
								%s.value=%w;
								%s.setColor(getColorIDTable(%w));
							}
							else if(%w$="vector") {
								for(%k=0;%k<3;%k++) {
									%s.getObject(%k).setValue(getWord($EFFP[%i,%j],%k));
								}
							}
							else if(%w$="list"||%w$="dataBlock") {
								%s.forceClose();
								%c=%s.findText($EFFP[%i,%j]);
								if(%c!=-1)
									%s.setSelected(%c);
								else if(%w$="dataBlock")
									%e=1;
							}
							else
								%s.setValue($EFFP[%i,%j]);
						}
					}
					else
						%e=1;
				}
				else
					%e=1;
			}
			else
				%e=1;
			if(%e) {
				%r.getObject(2).setSelected(-1);
				%e=0;
				%v=1;
			}
			else {
				%r.getObject(0).setValue($EFFE[%i]);
				%r.getObject(1).setValue($EFFD[%i]);
			}
				
		}
		if(%v)
			clientCmdMessageBoxOk("Event Favorites Error","Error loading while loading events. The server may be missing events or datablocks you have in your favorite, or you are missing named bricks.");
	}
}
package EF {
	function disconnect() {
		Parent::disconnect();
		$EFP=0;
	}
	function WrenchEventsDlg::onWake(%this) {
		Parent::onWake(%this);
		for(%i=1;%i<11;%i++) { 
			if(isFile($EFD@getSubStr(%i,strLen(%i)-1,1)@".cs"))
				%t=255;
			else
				%t=128;
			$EFB[%i].mColor="255 255 255 "@%t;
		}
	}
};
activatePackage(EF);
function EFG() {
	if(!$EFG) {
		for(%i=1;%i<11;%i++) {
			%t=getSubStr(%i,strLen(%i)-1,1);
			$EFB[%i]=new GuiBitmapButtonCtrl() {
				profile="BlockButtonProfile";
				horizSizing="right";
				vertSizing="bottom";
				position=492+%i*20@" 3";
				extent="19 19";
				minExtent="8 2";
				visible=1;
				command="EFC("@%t@");";
				accelerator=1;
				text=%t;
				groupNum=-1;
				buttonType="PushButton";
				bitmap="base/client/ui/button2";
				lockAspectRatio=0;
				alignLeft=0;
				overflowImage=0;
				mKeepCached=0;
				mColor="255 255 255 255";
			};
			WrenchEvents_Window.add($EFB[%i]);
		}
		%b=new GuiSwatchCtrl(EFH) {
			profile="BlockWindowProfile";
			horizSizing="right";
			vertSizing="bottom";
			position="442 25";
			extent="269 27";
			minExtent="8 2";
			visible=0;
			color="78 83 235 240";
			new GuiTextCtrl() {
				profile="BlockWindowProfile";
				horizSizing="center";
				vertSizing="bottom";
				position="22 3";
				extent="225 18";
				minExtent="8 2";
				visible=1;
				text="^^^ Click a number to set favorites ^^^";
				maxLength=255;
			};
		};
		WrenchEvents_Window.add(%b);
		%b=new GuiBitmapButtonCtrl() {
			profile="BlockButtonProfile";
			horizSizing="right";
			vertSizing="bottom";
			position="442 3";
			extent="62 19";
			minExtent="8 2";
			visible=1;
			command="$EFS=!$EFS; EFH.setVisible(!EFH.visible);";
			text="Set Favs ";
			groupNum=-1;
			buttonType="Push Button";
			bitmap="base/client/ui/button1";
			lockAspectRatio=0;
			alignLeft=0;
			overflowImage=0;
			mKeepCached=0;
			mColor="255 255 255 255";
		};
		WrenchEvents_Window.add(%b);
		$EFG=1;
	}
}
schedule(0,0,EFG);